/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef __SIZEOF_VARIABLE_EVALUATION_H
#define __SIZEOF_VARIABLE_EVALUATION_H 0

#include "string"

#include "CubeStringEvaluation.h"
#include "CubePLMemoryManager.h"
namespace cube
{
class SizeOfVariableEvaluation : public StringEvaluation
{
protected:
    CubePLMemoryManager* memory;
    MemoryAdress         variable;
    std::string          variable_name;
    KindOfVariable       kind;
public:
    SizeOfVariableEvaluation( std::string          _variable,
                              CubePLMemoryManager* _manager  ) : StringEvaluation(), memory( _manager ),  variable( memory->register_variable( _variable ) ), variable_name( _variable )
    {
        kind = memory->kind_of_variable( variable_name );
    };
    ~SizeOfVariableEvaluation();

    virtual
    double
    eval();

//     virtual
//     double
//     eval( Cnode *, CalculationFlavour, Thread *, CalculationFlavour ) { return eval(); };
//
//     virtual
//     double
//     eval( Cnode *, CalculationFlavour, Thread *, Thread *, CalculationFlavour   ) { return eval(); };

    virtual
    double
    eval( Cnode*, CalculationFlavour, Sysres*, CalculationFlavour   )
    {
        return eval();
    };

//     virtual
//     double
//     eval( Cnode *, CalculationFlavour, Process *, CalculationFlavour   ) { return eval(); };
//
//     virtual
//     double
//     eval( Cnode *, CalculationFlavour, Node *, CalculationFlavour   ) { return eval(); };
//
//     virtual
//     double
//     eval( Cnode *, CalculationFlavour, Machine *, CalculationFlavour   ) { return eval(); };
//
    virtual
    double
    eval( Cnode*, CalculationFlavour )
    {
        return eval();
    };


    virtual
    string
    strEval();



    virtual
    void
    print()
    {
        cout << "sizeof(" << variable_name << ")";
    };
};
};

#endif
